/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: list.gi,v 1.2 2002/05/27 15:08:45 malekith Exp $
 *
 * Standard library for Gont, List module implementation.
 */

union <'a>t {
	void Nil;
	*['a, <'a>t] Cons;
}

int length(<'a>t l);
void iter(*(void ('a)) f, <'a>t l);
<'b>t map(*('b ('a)) f, <'a>t l);
<'a>t concat(<'a>t x, <'a>t y);
<'a>t filter(*(bool ('a)) f, <'a>t l);
'a fold_left(*('a ('a, 'b)) f, 'a init, <'b>t li);
<'a>t qsort(*(int ('a, 'a)) cmp, <'a>t l);

/* EOF */
